diff --git a/test/unit/setup_preflight_test.rb b/test/unit/setup_preflight_test.rb
new file mode 100644
index 000000000..c798f5970
--- /dev/null
+++ b/test/unit/setup_preflight_test.rb
@@ -0,0 +1,127 @@
+require "test_helper"
+require "hive/setup/preflight"
+
+# U3 — dependency preflight rows. All probes run through an injected runner
+# so no real binary needs to exist in CI.
+class SetupPreflightTest < Minitest::Test
+  include HiveTestHelper
+
+  def test_all_present_reports_zero_warnings
+    preflight = preflight_with(
+      "ruby -v" => [ "ruby 3.4.1 (2024-12-25)\n", true ],
+      "git --version" => [ "git version 2.43.0\n", true ],
+      "bundle --version" => [ "Bundler version 2.5.0\n", true ],
+      "tmux -V" => [ "tmux 3.4\n", true ],
+      "node --version" => [ "v20.11.0\n", true ],
+      "npm --version" => [ "10.2.0\n", true ],
+      "claude --version" => [ "#{Hive::MIN_CLAUDE_VERSION} (Claude Code)\n", true ],
+      "codex --version" => [ "codex-cli 0.9.0\n", true ],
+      "gh --version" => [ "gh version 2.62.0\n", true ],
+      "gh auth status" => [ "", true ],
+      "sqlite3 --version" => [ "3.45.1 2024-01-15\n", true ]
+    )
+
+    capture_io { preflight.call }
+
+    assert_empty preflight.warnings, "everything present ⇒ zero warnings"
+    assert_empty preflight.hard_failures
+    assert preflight.rows.all? { |row| row.status == "present" },
+           -> { preflight.rows.map { |r| [ r.name, r.status ] }.inspect }
+  end
+
+  def test_missing_codex_is_a_loud_warning_not_a_hard_failure
+    preflight = green_preflight({ codex: :missing })
+
+    capture_io { preflight.call }
+
+    assert_includes preflight.warnings, "codex"
+    assert_empty preflight.hard_failures, "a missing agent CLI must not fail setup"
+    codex = preflight.rows.find { |row| row.name == "codex" }
+    assert_equal "missing", codex.status
+    assert_match(/codex login --device-auth/, codex.fix)
+  end
+
+  def test_too_old_ruby_is_version_too_old_and_hard_fails
+    preflight = green_preflight({ "ruby -v" => [ "ruby 3.1.2 (2022)\n", true ] })
+
+    capture_io { preflight.call }
+
+    ruby_row = preflight.rows.find { |row| row.name == "ruby" }
+    assert_equal "version_too_old", ruby_row.status
+    assert_match(/3\.1\.2 found, 3\.4\+ required/, ruby_row.message)
+    assert_includes preflight.hard_failures, "ruby"
+  end
+
+  def test_unauthenticated_gh_names_the_exact_fix_command_without_attempting_login
+    commands = []
+    preflight = green_preflight(
+      ({ "gh auth status" => [ "", false ] }),
+      spy: commands
+    )
+
+    capture_io { preflight.call }
+
+    gh = preflight.rows.find { |row| row.name == "gh" }
+    assert_equal "present", gh.status, "the binary works; only credentials are missing"
+    assert_match(/NOT authenticated/, gh.message)
+    assert_match(/gh auth login/, gh.message)
+    # Diagnose-only contract: no login/auth command is ever spawned.
+    refute commands.any? { |argv| argv.join(" ") =~ /auth\s+login/ },
+           "preflight must NEVER run `gh auth login` (or any auth flow)"
+  end
+
+  def test_missing_qmd_offers_hive_owned_bootstrap_command
+    preflight = green_preflight({ qmd: :missing })
+
+    capture_io { preflight.call }
+
+    qmd = preflight.rows.find { |row| row.name == "qmd" }
+    assert_equal "missing", qmd.status
+    assert_match(/@tobilu\/qmd/, qmd.fix)
+    refute_includes preflight.hard_failures, "qmd"
+  end
+
+  private
+
+  # A fully-green toolchain; per-test overrides replace individual probe
+  # results. Keys are full argv strings ("ruby -v"); `qmd` uses its finder
+  # seam instead of the runner (:missing or an executable path).
+  def green_preflight(overrides = {}, spy: nil)
+    # Symbol keys are binary names — expand to their probe argv.
+    overrides = overrides.to_h do |key, value|
+      key.is_a?(Symbol) && key != :qmd ? [ "#{key} --version", value ] : [ key, value ]
+    end
+    probes = {
+      "ruby -v" => [ "ruby 3.4.1 (2024-12-25)\n", true ],
+      "git --version" => [ "git version 2.43.0\n", true ],
+      "bundle --version" => [ "Bundler version 2.5.0\n", true ],
+      "tmux -V" => [ "tmux 3.4\n", true ],
+      "node --version" => [ "v20.11.0\n", true ],
+      "npm --version" => [ "10.2.0\n", true ],
+      "claude --version" => [ "#{Hive::MIN_CLAUDE_VERSION} (Claude Code)\n", true ],
+      "codex --version" => [ "codex-cli 0.9.0\n", true ],
+      "gh --version" => [ "gh version 2.62.0\n", true ],
+      "gh auth status" => [ "", true ],
+      "sqlite3 --version" => [ "3.45.1 2024-01-15\n", true ]
+    }.merge(overrides.except(:qmd))
+    # :missing / nil entries mean "binary absent" — normalize them away so
+    # the runner's default missing-answer kicks in.
+    overrides.except(:qmd).each_key do |key|
+      next unless [ :missing, nil ].include?(probes[key])
+
+      probes.delete(key)
+    end
+
+    runner = lambda do |argv|
+      spy << argv if spy
+      probes[argv.join(" ")] || [ "", false ]
+    end
+    qmd = overrides.key?(:qmd) ? overrides[:qmd] == :missing ? nil : "/fake/qmd/bin/qmd" : "/fake/qmd/bin/qmd"
+
+    Hive::Setup::Preflight.new(runner: runner, qmd_finder: -> { qmd })
+  end
+
+  def preflight_with(table)
+    green_preflight(table)
+  end
+end
diff --git a/test/unit/web/app_provisioner_test.rb b/test/unit/web/app_provisioner_test.rb
new file mode 100644
index 000000000..d37f5af90
--- /dev/null
+++ b/test/unit/web/app_provisioner_test.rb
@@ -0,0 +1,166 @@
+require "test_helper"
+require "hive/web/app_provisioner"
+
+# U2 — version-matched web app provisioning for gem installs. The network
+# seam (download callable), bundler runner, and XDG data home are all
+# stubbed/sandboxed so these tests never touch the network or the real
+# ~/.local/share.
+class WebAppProvisionerTest < Minitest::Test
+  include HiveTestHelper
+
+  def setup
+    @downloads = {}
+    @download_count = 0
+  end
+
+  def test_fresh_install_downloads_extracts_bundles_and_marks_provisioned
+    with_xdg_home do |dir|
+      provisioner = build_provisioner(dir)
+
+      result = capture_io { provisioner.provision }
+
+      target = provisioner.target_dir
+      assert_equal File.join(dir, "data", "hive", "web-app", Hive::VERSION), target
+      assert File.file?(File.join(target, "config", "application.rb"))
+      assert File.file?(File.join(target, ".hive-provisioned"))
+      # hive-cli path dependency rewritten to the installed gem's location.
+      gemfile = File.read(File.join(target, "Gemfile"))
+      assert_includes gemfile, %Q{gem "hive-cli", path: "#{Gem::Specification.find_by_name("hive-cli").full_gem_path}"}
+      refute_includes gemfile, 'path: ".."'
+      # bundle install ran with BUNDLE_PATH scoped inside the app dir.
+      assert_equal %w[bundle install], @runner_calls.last
+      assert_match(/#{Regexp.escape(File.join(target, ".bundle"))}/, @runner_envs.last.fetch("BUNDLE_PATH"))
+      assert result
+    end
+  end
+
+  def test_rerun_is_idempotent_and_does_not_re_download
+    with_xdg_home do |dir|
+      provisioner = build_provisioner(dir)
+      capture_io { provisioner.provision }
+      downloads_before = @download_count
+
+      second = build_provisioner(dir)
+      assert second.already_provisioned?
+      capture_io { assert_equal second.target_dir, second.provision }
+
+      assert_equal downloads_before, @download_count, "re-run must not re-download"
+    end
+  end
+
+  def test_version_bump_provisions_a_new_dir_and_leaves_the_old_one
+    with_xdg_home do |dir|
+      old = build_provisioner(dir, version: "0.0.1")
+      capture_io { old.provision }
+
+      new = build_provisioner(dir, version: "9.9.9")
+      capture_io { new.provision }
+
+      assert File.directory?(old.target_dir), "old version dir stays for rollback"
+      assert File.directory?(new.target_dir)
+      refute_equal old.target_dir, new.target_dir
+    end
+  end
+
+  def test_checksum_mismatch_is_refused
+    with_xdg_home do |dir|
+      @downloads["bad-sha"] = "0" * 64
+      provisioner = build_provisioner(dir, sha: "0" * 64)
+
+      e = assert_raises(Hive::Error) { capture_io { provisioner.provision } }
+
+      assert_match(/checksum verification/, e.message)
+      refute File.file?(File.join(provisioner.target_dir, "config", "application.rb")),
+             "a failed checksum must not leave an installed app behind"
+    end
+  end
+
+  def test_network_failure_raises_typed_error_with_manual_instructions
+    with_xdg_home do |dir|
+      provisioner = build_provisioner(dir, fail_download: true)
+
+      e = assert_raises(Hive::Error) { capture_io { provisioner.provision } }
+
+      assert_match(/could not download/, e.message)
+      assert_match(/HIVEBOX_WEB_APP_DIR/, e.message)
+    end
+  end
+
+  def test_tarball_with_single_top_level_dir_is_unwrapped
+    with_xdg_home do |dir|
+      # build_fixture_tarball nests everything under hive-web-<version>/
+      provisioner = build_provisioner(dir)
+
+      capture_io { provisioner.provision }
+
+      assert File.file?(File.join(provisioner.target_dir, "config", "application.rb"))
+    end
+  end
+
+  def test_gem_without_hive_cli_dependency_cannot_be_rewritten
+    with_xdg_home do |dir|
+      @fixture_options = { gemfile_without_hive_cli: true }
+      provisioner = build_provisioner(dir)
+
+      e = assert_raises(Hive::Error) { capture_io { provisioner.provision } }
+
+      assert_match(/hive-cli path dependency/, e.message)
+    ensure
+      @fixture_options = nil
+    end
+  end
+
+  private
+
+  def fixture_tarball(version)
+    root = File.join(Dir.mktmpdir("hive-web-fixture"), "hive-web-#{version}")
+    FileUtils.mkdir_p(File.join(root, "config"))
+    FileUtils.mkdir_p(File.join(root, "bin"))
+    File.write(File.join(root, "config", "application.rb"), "# fixture\n")
+    File.write(File.join(root, "bin", "rails"), "#!/bin/sh\n")
+    if @fixture_options&.fetch(:gemfile_without_hive_cli, false)
+      File.write(File.join(root, "Gemfile"), "gem \"rails\"\n")
+    else
+      File.write(File.join(root, "Gemfile"), "gem \"rails\"\ngem \"hive-cli\", path: \"..\"\n")
+    end
+    tarball = File.join(File.dirname(root), "hive-web-#{version}.tar.gz")
+    system("tar", "-czf", tarball, "-C", File.dirname(root), "hive-web-#{version}", exception: true)
+    tarball
+  end
+
+  def build_provisioner(xdg_root, version: Hive::VERSION, sha: nil, fail_download: false)
+    fixture = fixture_tarball(version)
+    digest = sha || Digest::SHA256.file(fixture).hexdigest
+    @runner_calls = []
+    @runner_envs = []
+
+    downloader = lambda do |url, dest|
+      raise Net::HTTPError.new("offline", nil) if fail_download
+
+      @download_count += 1
+      if url.end_with?(".sha256")
+        File.write(dest, "#{digest}  hive-web.tar.gz\n")
+        @downloads[:sha] = url
+      else
+        FileUtils.cp(fixture, dest)
+        @downloads[:tarball] = url
+      end
+      dest
+    end
+
+    runner = lambda do |env, *argv|
+      @runner_calls << argv
+      @runner_envs << env
+      # Real extraction (hermetic — the archive is our fixture), but the
+      # bundler step is stubbed so no gems are installed.
+      argv[0] == "tar" ? system(*argv) : true
+    end
+
+    Hive::Web::AppProvisioner.new(
+      version: version,
+      data_home: File.join(xdg_root, "data", "hive"),
+      download: downloader,
+      runner: runner
+    )
+  end
+end
diff --git a/web/app/controllers/admin/daemon_controller.rb b/web/app/controllers/admin/daemon_controller.rb
new file mode 100644
index 000000000..3a3cb7c7a
--- /dev/null
+++ b/web/app/controllers/admin/daemon_controller.rb
@@ -0,0 +1,102 @@
+require "hive/setup/daemon_guard"
+
+# U5 — web-visible daemon health + one-click repair. Health reuses the same
+# DaemonGuard the CLI setup flow uses (pidfile liveness + unit binary
+# check); repair re-runs the daemon installer with --force in a BOUNDED
+# subprocess so a hung systemctl can never wedge a Puma thread forever.
+#
+# Gating: this controller sits behind the application-wide require_login,
+# which is a no-op only when the effective auth mode is `none` — and that
+# mode is boot-refused on non-loopback binds. As defense in depth, repair
+# additionally refuses when auth mode is none AND the request did not
+# originate from a loopback address.
+class Admin::DaemonController < ApplicationController
+  REPAIR_TIMEOUT_SEC = 120
+
+  def show
+    render json: health_payload
+  end
+
+  def repair
+    unless repair_permitted?
+      return render json: { ok: false, error: "repair refused in no-auth mode off loopback" },
+                    status: :forbidden
+    end
+
+    result = bounded_repair_subprocess
+    if result[:ok]
+      render json: { ok: true, guard: post_repair_health }
+    else
+      render json: { ok: false, error: result[:error] }, status: :internal_server_error
+    end
+  end
+
+  private
+
+  def guard
+    @guard ||= Hive::Setup::DaemonGuard.new
+  end
+
+  def health_payload
+    result = guard.check
+    {
+      "ok" => result.healthy?,
+      "status" => result.status,
+      "running" => result.running,
+      "pid" => result.pid,
+      "unit_path" => result.unit_path,
+      "service_binary" => result.service_binary,
+      "expected_binary" => result.expected_binary,
+      "detail" => result.detail
+    }
+  end
+
+  # Repair mutates a system service — never allow it implicitly. The CLI's
+  # U1 decision already refuses `none`-mode non-loopback binds; this check
+  # closes the residual case of an explicit unsafe-public no-auth box being
+  # reached from another machine.
+  def repair_permitted?
+    return true unless ENV["HIVEBOX_AUTH_MODE"] == "none"
+
+    request.remote_ip.to_s =~ /\A(127\.|::1\z)/ ? true : false
+  end
+
+  # Run `hive daemon install --force --json` as a child process with a hard
+  # wall clock. waitpid in a polling loop so Timeout semantics actually kill
+  # something (a blocking waitpid would ignore Ruby-level timeouts).
+  def bounded_repair_subprocess
+    hive_bin = guard.expected_binary
+    reader, writer = IO.pipe
+    pid = Process.spawn(hive_bin, "daemon", "install", "--force", "--json",
+                        out: writer, err: writer)
+    writer.close
+    deadline = Time.now + REPAIR_TIMEOUT_SEC
+    status = nil
+    output = +""
+    loop do
+      remaining = deadline - Time.now
+      if remaining <= 0
+        Process.kill("KILL", pid) rescue nil
+        Process.wait(pid) rescue nil
+        return { ok: false, error: "daemon repair timed out after #{REPAIR_TIMEOUT_SEC}s" }
+      end
+      ready = IO.select([reader], nil, nil, [remaining, 0.5].min)
+      output << reader.read_nonblock(65_536) if ready && ready[0].include?(reader)
+      _, status = Process.waitpid2(pid, Process::WNOHANG)
+      break if status
+    end
+    reader.close
+    if status.success?
+      { ok: true, output: output }
+    else
+      { ok: false, error: "daemon repair exited #{status.exitstatus}: #{output.lines.last.to_s.strip}" }
+    end
+  rescue StandardError => e
+    { ok: false, error: "#{e.class}: #{e.message}" }
+  end
+
+  def post_repair_health
+    @guard = nil # force a fresh probe after the subprocess rewrote the unit
+    health_payload
+  end
+end
diff --git a/web/app/controllers/application_controller.rb b/web/app/controllers/application_controller.rb
index 2a1e5e28f..969684b79 100644
--- a/web/app/controllers/application_controller.rb
+++ b/web/app/controllers/application_controller.rb
@@ -50,6 +50,13 @@ class ApplicationController < ActionController::Base
   end
 
   def require_login
+    # Local (non-Docker) mode: `hive web` resolves the effective auth mode
+    # from web.auth + the bind address and exports it. `none` means a
+    # loopback-only UI with no sign-in — skip the gate entirely. The
+    # non-loopback + none combination is refused at boot by the CLI, so
+    # this env can only be "none" on a loopback bind in practice.
+    return if ENV["HIVEBOX_AUTH_MODE"] == "none"
+
     return redirect_to login_path unless current_login
 
     # Sessions must track the CURRENT owner, not the owner at sign-in time:
diff --git a/web/app/controllers/status_controller.rb b/web/app/controllers/status_controller.rb
index c44440a83..65ba4172d 100644
--- a/web/app/controllers/status_controller.rb
+++ b/web/app/controllers/status_controller.rb
@@ -1,6 +1,24 @@
+require "hive/setup/daemon_guard"
+
 class StatusController < ApplicationController
   def index
     @payload = StatusBroadcaster.snapshot
     @projects = @payload.fetch("projects", [])
   end
+
+  private
+
+  # Cheap, non-mutating probe for the U5 banner: pidfile liveness + unit
+  # binary comparison. Nil on any failure so a broken local install can
+  # never take the dashboard down (the banner simply does not render).
+  def daemon_banner_health
+    @daemon_banner_health ||= begin
+      Hive::Setup::DaemonGuard.new.check
+    rescue StandardError => e
+      Rails.logger.warn("daemon banner probe failed: #{e.class}: #{e.message}")
+      nil
+    end
+  end
+
+  helper_method :daemon_banner_health
 end
diff --git a/web/app/views/status/index.html.erb b/web/app/views/status/index.html.erb
index 25bcdf793..67e22b65a 100644
--- a/web/app/views/status/index.html.erb
+++ b/web/app/views/status/index.html.erb
@@ -9,6 +9,28 @@
 <% end %>
 <%= turbo_stream_from StatusBroadcaster::CHANNEL %>
 
+<%# Local-mode daemon banner (U5): red strip with a Repair button when the
+    daemon is down (running unit, dead pidfile) or its service unit drifted
+    onto a different hive binary. Deliberately silent on not_installed /
+    unsupported hosts so the hivebox container and pre-install machines keep
+    today's clean dashboard. %>
+<% if (health = daemon_banner_health) && (health.status == "drifted" || (health.status == "ok" && !health.running)) %>
+  <div class="daemon-banner" role="alert" data-controller="daemon-repair">
+    <span class="daemon-banner-text">
+      <% if health.status == "drifted" %>
+        Daemon binary drift detected — the configured daemon unit runs a different hive install.
+      <% else %>
+        Daemon is not running — tasks will not dispatch automatically.
+      <% end %>
+      <%= button_to "Repair", admin_daemon_repair_path, method: :post,
+            class: "btn btn-sm btn-danger",
+            form: { data: { daemon_repair_target: "form" } },
+            data: { confirm: "Reinstall and restart the hive-daemon service with this CLI's binary?" } %>
+    </span>
+    <small><%= health.detail %></small>
+  </div>
+<% end %>
+
 <%# TUI left-pane parity: the rail filters the grid client-side (buttons,
     not links — a navigation would discard the permanent composer's typed
     text). The controller wraps rail AND grid; it re-applies the filter
diff --git a/web/config/routes.rb b/web/config/routes.rb
index 659576df3..608f5497a 100644
--- a/web/config/routes.rb
+++ b/web/config/routes.rb
@@ -52,4 +52,10 @@ Rails.application.routes.draw do
   get  "telegram" => "telegram#show", as: :telegram
   post "telegram" => "telegram#update", as: :update_telegram
   post "telegram/test" => "telegram#test", as: :test_telegram
+
+  # Local-mode daemon health/repair (U5). Gated by require_login like every
+  # other page; repair additionally refuses no-auth non-loopback requests
+  # (defense in depth — the CLI already refuses to boot that combination).
+  get  "admin/daemon" => "admin/daemon#show", as: :admin_daemon
+  post "admin/daemon/repair" => "admin/daemon#repair", as: :admin_daemon_repair
 end
diff --git a/web/test/integration/admin_daemon_test.rb b/web/test/integration/admin_daemon_test.rb
new file mode 100644
index 000000000..176e8815f
--- /dev/null
+++ b/web/test/integration/admin_daemon_test.rb
@@ -0,0 +1,138 @@
+require "test_helper"
+require "hive/setup/daemon_guard"
+
+# U5 — the web-visible daemon health/repair surface: the dashboard banner
+# renders when the daemon is down/drifted, the JSON health endpoint reports
+# guard status, and the repair POST is gated by the effective auth mode.
+class AdminDaemonTest < ActionDispatch::IntegrationTest
+  setup do
+    create_hive_project!
+    configure_owner!(owner: "alice")
+    ENV.delete("HIVEBOX_AUTH_MODE")
+    # DaemonGuard anchors service-unit paths on HOME; sandbox it so tests
+    # never touch the developer's real LaunchAgents/systemd dirs.
+    @home_sandbox = Dir.mktmpdir("hive-web-home")
+    @old_home = ENV["HOME"]
+    ENV["HOME"] = @home_sandbox
+  end
+
+  teardown do
+    ENV["HOME"] = @old_home
+    FileUtils.rm_rf(@home_sandbox)
+    FileUtils.rm_f(File.join(Hive::Paths.state_home, ".daemon.pid"))
+  end
+
+  def install_daemon_unit(binary)
+    Hive::Commands::Daemon::ServiceInstaller.new(
+      host_os: "linux", home: @home_sandbox, binary_path: binary,
+      systemctl_available: true, runner: ->(_argv) { true }
+    ).install!(autostart: false)
+  end
+
+  def write_live_daemon_pidfile
+    path = File.join(Hive::Paths.state_home, ".daemon.pid")
+    FileUtils.mkdir_p(File.dirname(path))
+    payload = { "pid" => Process.pid, "process_start_time" => Hive::Lock.send(:process_start_time, Process.pid) }
+    File.write(path, payload.to_yaml)
+  end
+
+  test "health endpoint reports not_running when no daemon unit exists" do
+    sign_in!
+    get "/admin/daemon"
+    assert_response :success
+    body = response.parsed_body
+    assert_equal "not_installed", body["status"]
+    assert_equal false, body["running"]
+    assert body["detail"].present?
+  end
+
+  test "health endpoint reports a drifted unit with both binaries" do
+    install_daemon_unit("/opt/other/hive")
+    sign_in!
+    get "/admin/daemon"
+    assert_response :success
+    body = response.parsed_body
+    assert_equal "drifted", body["status"]
+    assert_equal "/opt/other/hive", body["service_binary"]
+    assert body["expected_binary"].present?
+  end
+
+  test "dashboard shows the banner with Repair on binary drift" do
+    install_daemon_unit("/opt/other/hive")
+    sign_in!
+    get "/"
+    assert_response :success
+    assert_match(/daemon-banner/, response.body)
+    assert_match(/Daemon binary drift/, response.body)
+    assert_match(admin_daemon_repair_path, response.body)
+  end
+
+  def install_matching_daemon_unit
+    # Install a unit whose binary matches what the web-tier guard resolves
+    # as "this CLI" (InvokedBinary.path → PATH lookup fallback).
+    expected = Hive::Setup::DaemonGuard.new(home: @home_sandbox).expected_binary
+    Hive::Commands::Daemon::ServiceInstaller.new(
+      host_os: "linux", home: @home_sandbox, binary_path: expected,
+      systemctl_available: true, runner: ->(_argv) { true }
+    ).install!(autostart: false)
+  end
+
+  test "dashboard shows the banner when the daemon is stopped" do
+    # A matching unit (status ok) but no live pidfile → down daemon.
+    install_matching_daemon_unit
+
+    sign_in!
+    get "/"
+    assert_response :success
+    assert_match(/Daemon is not running/, response.body)
+  end
+
+  test "dashboard hides the banner when the daemon is healthy" do
+    install_matching_daemon_unit
+    write_live_daemon_pidfile
+
+    sign_in!
+    get "/"
+    assert_response :success
+    refute_match(/daemon-banner/, response.body)
+  end
+
+  test "repair refuses in no-auth mode from a non-loopback request" do
+    # The CLI boot-refuses this combination (auth none + non-loopback bind);
+    # this pins the controller's defense-in-depth gate anyway.
+    ENV["HIVEBOX_AUTH_MODE"] = "none"
+    controller = Admin::DaemonController.new
+    remote = ActionDispatch::TestRequest.create(
+      "REMOTE_ADDR" => "203.0.113.7", "HTTP_X_FORWARDED_FOR" => "203.0.113.7"
+    )
+    controller.set_request!(remote)
+    refute controller.send(:repair_permitted?),
+           "repair must refuse no-auth requests from non-loopback addresses"
+
+    loopback = ActionDispatch::TestRequest.create("REMOTE_ADDR" => "127.0.0.1")
+    controller.set_request!(loopback)
+    assert controller.send(:repair_permitted?), "loopback no-auth repair stays allowed"
+  end
+
+  test "repair invokes hive daemon install --force in a bounded subprocess" do
+    stub_hive = File.join(ENV["HIVE_TEST_HOME_ROOT"], "stub-hive-#{SecureRandom.hex(4)}")
+    log_file = "#{stub_hive}.log"
+    File.write(stub_hive, <<~SH)
+      #!/bin/sh
+      echo "$@" >> #{log_file}
+      echo '{"schema":"hive-daemon-install","ok":true,"outcome":"written"}'
+      exit 0
+    SH
+    FileUtils.chmod(0o755, stub_hive)
+
+    Hive::Setup::DaemonGuard.stub(:new, -> { Hive::Setup::DaemonGuard.new(binary_path: stub_hive, host_os: "unsupported") }) do
+      sign_in!
+      post "/admin/daemon/repair"
+      assert_response :success
+      assert_equal true, response.parsed_body["ok"], response.parsed_body.inspect
+    end
+
+    assert_match(/daemon install --force --json/, File.read(log_file)),
+                 "repair must invoke `hive daemon install --force`"
+  end
+end
diff --git a/web/test/integration/local_auth_mode_test.rb b/web/test/integration/local_auth_mode_test.rb
new file mode 100644
index 000000000..2ba011ffb
--- /dev/null
+++ b/web/test/integration/local_auth_mode_test.rb
@@ -0,0 +1,41 @@
+require "test_helper"
+
+# U1 — the Rails require_login gate honors HIVEBOX_AUTH_MODE=none (local
+# loopback mode) while the default github gate stays active.
+class LocalAuthModeTest < ActionDispatch::IntegrationTest
+  def with_auth_mode(mode)
+    old = ENV["HIVEBOX_AUTH_MODE"]
+    ENV["HIVEBOX_AUTH_MODE"] = mode
+    yield
+  ensure
+    old.nil? ? ENV.delete("HIVEBOX_AUTH_MODE") : ENV["HIVEBOX_AUTH_MODE"] = old
+  end
+
+  test "auth mode none reaches the dashboard without a session" do
+    create_hive_project!
+    with_auth_mode("none") do
+      get "/"
+      assert_response :success
+    end
+  end
+
+  test "default github gate still redirects an anonymous visitor" do
+    create_hive_project!
+    # No HIVEBOX_AUTH_MODE set — production parity: anonymous → login.
+    ENV.delete("HIVEBOX_AUTH_MODE")
+    configure_owner!(owner: "alice")
+    get "/"
+    assert_redirected_to login_path
+  end
+
+  test "auth mode github still gates even when a stale local session exists" do
+    create_hive_project!
+    configure_owner!(owner: "alice")
+    with_auth_mode("github") do
+      # Dev/test seam signs in a NON-owner; the owner check must still fire.
+      get "/dev_login", params: { as: "mallory" }
+      get "/"
+      assert_redirected_to login_path
+    end
+  end
+end
